// test_cordic.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"
#include "Fixed.h"
#include <iostream>
#include <Windows.h>
#include <vector>

typedef long long int int64;
typedef unsigned long long int uint64;
typedef int int32;
typedef unsigned int uint32;
typedef short int16;
typedef unsigned short uint16;

//function pointer typedef for the atan2 function signature
typedef CFixed_15_16 (*atan2_func)(CFixed_15_16 y, CFixed_15_16 x);
typedef void (*sincos_func)(CFixed_15_16 angle, CFixed_15_16 &sin_out, CFixed_15_16 &cos_out);

int64 GetTimeUs64(void);
void calculate_atan2_function_average_time(CFixed_15_16 x_var, CFixed_15_16 y_var,  atan2_func atan2_func_ptr);
void calculate_sincos_function_average_time(CFixed_15_16 angle, sincos_func sincos_func_ptr);

using namespace std;

int _tmain(int argc, _TCHAR* argv[])
{
    CFixed_15_16 y_var;
    CFixed_15_16 x_var;

    cout << endl <<"====================ATAN2_APPROX===================" << endl << endl;

    cout << "QUADRANT 1 => x: 1, y: 1" << endl << endl;
    y_var.SetInternalValue(1 << 16);
    x_var.SetInternalValue(1 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);

    cout << endl << "QUADRANT 1 => x: 0, y: 1" << endl << endl;
    y_var.SetInternalValue(1 << 16);
    x_var.SetInternalValue(0 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);

    cout << endl << "QUADRANT 1 => x: 1, y: 0" << endl << endl;
    y_var.SetInternalValue(1 << 16);
    x_var.SetInternalValue(0 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);

    cout << endl << "QUADRANT 2 => x: -1, y: 1" << endl << endl;
    y_var.SetInternalValue(1 << 16);
    x_var.SetInternalValue(-1 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);

    cout << endl << "QUADRANT 2 => x: -1, y: 0" << endl << endl;
    y_var.SetInternalValue(0 << 16);
    x_var.SetInternalValue(-1 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);

    cout << endl << "QUADRANT 3 => x: -1, y: -1" << endl << endl;
    y_var.SetInternalValue(-1 << 16);
    x_var.SetInternalValue(-1 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);

    cout << endl << "QUADRANT 3 => x: 0, y: -1" << endl << endl;
    y_var.SetInternalValue(-1 << 16);
    x_var.SetInternalValue(0 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);

    cout << endl <<"QUADRANT 4 => x: 1, y: -1" << endl << endl;
    y_var.SetInternalValue(-1 << 16);
    x_var.SetInternalValue(1 << 16);

    cout << "ATAN2_APPROX" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_approx);
    cout << endl <<"ATAN2_CORDIC" << endl;
    calculate_atan2_function_average_time(x_var, y_var, atan2_cordic);
    

    cout << endl << "====================SINCOS_APPROX===================" << endl << endl;

    CFixed_15_16 res_var_sin = CFixed_15_16();
    CFixed_15_16 res_var_cos = CFixed_15_16();

    cout << endl <<"QUADRANT 1 => angle pi/4" << endl << endl;

    CFixed_15_16 angle = CFixed_15_16(51472);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    cout << endl <<"QUADRANT 1 => angle -7pi/4" << endl << endl;

    angle = CFixed_15_16(-1 * 51472 * 7);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    cout << endl <<"QUADRANT 2 => angle 3pi/4" << endl << endl;

    angle = CFixed_15_16(51472 * 3);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    cout << endl <<"QUADRANT 2 => angle -5pi/4" << endl << endl;

    angle = CFixed_15_16(-1 * 51472 * 7);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    cout << endl <<"QUADRANT 3 => angle 5pi/4" << endl << endl;

    angle = CFixed_15_16(51472 * 5);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    cout << endl <<"QUADRANT 3 => angle -3pi/4" << endl << endl;

    angle = CFixed_15_16(-1 * 51472 * 7);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    cout << endl <<"QUADRANT 4 => angle 7pi/4" << endl << endl;

    angle = CFixed_15_16(51472 * 7);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    cout << endl <<"QUADRANT 4 => angle -1pi/4" << endl << endl;

    angle = CFixed_15_16(-1 * 51472);

    cout << "SINCOS_APPROX" << endl;
    calculate_sincos_function_average_time(angle, sincos_approx);
    cout << endl <<"SINCOS_CORDIC" << endl;
    calculate_sincos_function_average_time(angle, sincos_cordic);

    for(;;);
}

int64 GetTimeUs64()
{
    /* Windows */
    FILETIME ft;
    LARGE_INTEGER li;

    /* Get the amount of 100 nano seconds intervals elapsed since January 1, 1601 (UTC) and copy it
    * to a LARGE_INTEGER structure. */
    GetSystemTimeAsFileTime(&ft);
    li.LowPart = ft.dwLowDateTime;
    li.HighPart = ft.dwHighDateTime;

    uint64 ret = li.QuadPart;
    ret -= 116444736000000000LL; /* Convert from file time to UNIX epoch time. */

    return ret;
}

void calculate_atan2_function_average_time(CFixed_15_16 x_var, CFixed_15_16 y_var,  atan2_func atan2_func_ptr)
{
    volatile int64 start_time;
    volatile int64 finish_time;
    int32 loop;
    int32 outside_loop;
    CFixed_15_16 res_var;
    vector<int> atan2_times_vector;

    //500 000 interations averaged over 10 runs 500 000 is an arbitrarily large number in order to get the time duration to be great enough for the GetTimeMs64 to capture it.

    for(outside_loop = 0; outside_loop < 10; ++outside_loop)
    {
        start_time = GetTimeUs64();

#ifdef _DEBUG
        for(loop = 0; loop < 50000; ++loop)
#else
        for(loop = 0; loop < 5000000; ++loop)
#endif
        {
            res_var = atan2_func_ptr(y_var, x_var);
        }

        finish_time = GetTimeUs64();
        atan2_times_vector.push_back(finish_time - start_time);
    }

    cout << "radians: " << res_var.ToDouble() << endl;
    cout << "averagetime: "  << [&atan2_times_vector](int summation)
    {
        for(auto itr = atan2_times_vector.begin(), end = atan2_times_vector.end(); itr != end; ++itr)
            summation += *itr;

        return summation/10;
    }(0) << "us" <<endl;
}

void calculate_sincos_function_average_time(CFixed_15_16 angle, sincos_func sincos_func_ptr)
{
    volatile int64 start_time;
    volatile int64 finish_time;
    int32 loop;
    int32 outside_loop;
    CFixed_15_16 res_var_sin;
    CFixed_15_16 res_var_cos;
    vector<int> sincos_times_vector;

    //500 000 interations averaged over 10 runs 500 000 is an arbitrarily large number in order to get the time duration to be great enough for the GetTimeMs64 to capture it.

    for(outside_loop = 0; outside_loop < 10; ++outside_loop)
    {
        start_time = GetTimeUs64();

#ifdef _DEBUG
        for(loop = 0; loop < 50000; ++loop)
#else
        for(loop = 0; loop < 5000000; ++loop)
#endif
        {
            sincos_func_ptr(angle, res_var_sin, res_var_cos);
        }

        finish_time = GetTimeUs64();
        sincos_times_vector.push_back(finish_time - start_time);
    }

    cout << "sin: " << res_var_sin.ToDouble() << endl;
    cout << "cos: " << res_var_cos.ToDouble() << endl;
    cout << "averagetime: "  << [&sincos_times_vector](int summation)
    {
        for(auto itr = sincos_times_vector.begin(), end = sincos_times_vector.end(); itr != end; ++itr)
            summation += *itr;

        return summation/10;
    }(0) << "us" << endl;
}
